/*
  Electron Owl a été créé dans le cadre d'un mémoire du Master Maltt de l'Université de Genève.
  Ainsi, ce code est libre d'utilisation sous la licence CC-BY-NC-SA (Pas d'utilisation commerciale, modification autorisée, libre d'utilisation à la condition de l'attribuer à l'auteur en citant le lien vers cette page)
*/
//Last update 10.08.2017 By JMM
"use strict";
window.onload = function () {
    // crée une variable qui permet de garder en mémoire les arbres entamés qui sera utilisée plus tard
    var threadStarted = {};
    // créé des choix joueur sous forme de boutons et change la narration
    function addGamerChoice(node, threadId, $root) {
        // ajoute la narration si elle existe
        var narration = "";
        if (node.children('narr').length > 0) {
            narration = $(node.children('narr')[0]).text();
        }
        $('#narration' + threadId).html(narration.replace(/\n/g, '<br/>'));
        node.children('choice').each(function () {
            const currentNode = $(this);
            const choixText = currentNode.attr('text');
            //crée un bouton qui contient le texte contenu dans l'élément choix joueur correspondant
            var choiceButton = $("<button>" + choixText + "</button>");
            $("#choixJ" + threadId).append(choiceButton);
            // réaction au clic de ce bouton
            choiceButton.on('click', function () {
                $("#choixJ" + threadId + " button").remove();
                // afficher les nouveaux choix
                addGamerChoice(currentNode, threadId, $root);
                // Si un arbre commence sur ce choix et qu'il n'a pas démarré, on le lance
                const startThread = currentNode.attr('startThread');
                if (startThread && startThread.length > 0) {
                    startThread.split(/\s+/).forEach(function (element) {
                        if (!threadStarted[element]) {
                            addGamerChoice($root.find('thread[threadId="' + element + '"]'), element, $root);
                            threadStarted[element] = true;
                        }
                    });
                }
            });
        });
    }
    // récupère les informations détenues dans threads.xml
    $.get("./threads.xml", function (data) {
        var $root;
        // suivant le navigateur le comportement est différent
        if ($(data).find('root').length == 0) {
            $root = $(data);
        } else {
            $root = $(data).find('root');
        }
        // affiche le titre du jeu dans l'onglet et en haut à gauche
        var title = $root.find('title').text();
        $("#nomdujeu").text(title);
        $("#titredujeu").text(title);
        // affiche le nom de l'auteur
        $("#narration").append('Créé par : <i>' + $root.find('author').text() + '</i><br/><br/>');
        // affiche le texte présentatif du jeu avant que le joueur ne clique sur "commencer"
        $("#narration").append($root.find('present').text().replace(/\n/g, '<br/>'));
        // le joueur choisit de lancer le jeu après avoir lu le texte de présentation
        $("#start").click(function () {
            $("#start").remove(); // enlève le bouton
            $('#narration').html(''); // enlève la présentation

            $root.children('thread').each(function () {
                var $thread = $(this);
                var threadId = $thread.attr("threadId");
                //Crée les div pour tout les arbres existants pour la partie narration et la partie jeu
                let divNarr = $('<div id="narration' + threadId + '"></div>');
                divNarr.appendTo("#narration");
                let divGamerChoice = $('<div id="choixJ' + threadId + '"></div>');
                divGamerChoice.appendTo("#owl");
                //lance les arbres qui démarrent au début
                if ($thread.attr("begin") == "true") {
                    threadStarted[threadId] = true;
                    addGamerChoice($thread, threadId, $root);
                } else {
                    // sinon, indiquer que le fil n'a pas été commencé
                    threadStarted[threadId] = false;
                }
            });
        }); 
    });
};